#include <extdll.h>
#include <sdk_util.h>
#include <pm_defs.h>
#include "distantsoundblock.h"

//
/*static void Debug_Sparks(const Vector &position, edict_t * pClient)
{
	MESSAGE_BEGIN(MSG_ONE, SVC_TEMPENTITY, 0, pClient);
		WRITE_BYTE( TE_SPARKS );
		WRITE_COORD( position.x );
		WRITE_COORD( position.y );
		WRITE_COORD( position.z );
	MESSAGE_END();
}*/
#define Debug_Sparks(a,b) do {;;} while(0)

//
#define GROUPMASK_PLAY 0x00000001
#define GROUPMASK_MUTE 0x00000010

//
 #define MAX_DISTANCE 1024.0f
 //#define MAX_DISTANCE 256.0f /* for debuging&testing */

//
typedef int (*setclientstates_callback_t)(edict_t * emiter, edict_t * listener);

//
pmplaysound_t OLD_PM_PlaySound;
playermove_t * g_pmove;

char player_is_connected[32];

char groupinfo_changed[32];
int groupinfo_old[32];
edict_t * groupinfo_entity;
int groupinfo_entity_old;

int game_groupmask;
int game_groupop;

//
static Vector GetEdictCenterOrigin(edict_t *ent) {
	Vector output;
	
	output.x = ent->v.origin.x + (ent->v.mins.x + ent->v.maxs.x) / 2.0f;
	output.y = ent->v.origin.y + (ent->v.mins.y + ent->v.maxs.y) / 2.0f;
	output.z = ent->v.origin.z + (ent->v.mins.z + ent->v.maxs.z) / 2.0f;
	
	return(output);
}

// volume doesn't seem to have much effect on how far you can hear sound
static float get_maxdistance(float attn, float vol) {
	return(MAX_DISTANCE/attn);
}

//
// Nasty hack to block sound going to players
//
static void SetClientStatesBy(edict_t * entity, setclientstates_callback_t check_func, int invert) {
	int is_player = 0;
	
	// Reset groupmask if set by gamedll
	if(game_groupmask || game_groupop)
		ENGINE_SETGROUPMASK(0, 0);
	
	memset(groupinfo_changed, 0, sizeof(groupinfo_changed));
	groupinfo_entity = 0;
	
	for(int i = 1; i <= gpGlobals->maxClients; i++) {
		edict_t * pEdict = INDEXENT(i);
		
		if(pEdict == entity)
			is_player = 1;
		
		//fake clients can be completly ignored (they wouldn't hear it anyway)
		if(player_is_connected[i-1] && !(pEdict->v.flags & FL_FAKECLIENT)) {
			//--
			groupinfo_changed[i-1] = 1;
			groupinfo_old[i-1] = pEdict->v.groupinfo;
			
			if(pEdict==entity)
				// I can hear myself
				pEdict->v.groupinfo = GROUPMASK_PLAY;
			else if(pEdict->v.flags & FL_PROXY)
				// Proxy hears all
				pEdict->v.groupinfo = GROUPMASK_PLAY;
			else if(!(*check_func)(entity, pEdict)) {
				// Set to 'too far' group
				pEdict->v.groupinfo = GROUPMASK_MUTE;
				Debug_Sparks(GetEdictCenterOrigin(entity), pEdict);
			}
			else
				// Set to 'close enough' group
				pEdict->v.groupinfo = GROUPMASK_PLAY;
			
			// handle groupmasks set by gamedll
			if(game_groupmask && groupinfo_old[i-1] && pEdict->v.groupinfo==GROUPMASK_PLAY) {
				if(game_groupop == GROUP_OP_AND ) {
					if(!(game_groupmask & groupinfo_old[i-1]))
						pEdict->v.groupinfo = GROUPMASK_MUTE;
				}
				else if(game_groupop == GROUP_OP_NAND) {
					if(game_groupmask & groupinfo_old[i-1])
						pEdict->v.groupinfo = GROUPMASK_MUTE;
				}
			}
		}
	}
	
	// Handle non-player objects
	if(!is_player) {
		groupinfo_entity = entity;
		groupinfo_entity_old = entity->v.groupinfo;
		entity->v.groupinfo = GROUPMASK_PLAY;
	}
	
	// Set new groupmasks active
	ENGINE_SETGROUPMASK((!invert)?GROUPMASK_PLAY:GROUPMASK_MUTE, GROUP_OP_AND);
}

//
// Back to default
//
static void ResetClientStates(void) {
	// Reset groupmask
	ENGINE_SETGROUPMASK(0, 0);
	
	for(int i = 1; i <= gpGlobals->maxClients; i++) {
		if(groupinfo_changed[i-1]) {
			edict_t * pEdict = INDEXENT(i);
			pEdict->v.groupinfo = groupinfo_old[i-1];
			groupinfo_changed[i-1] = 0;
		}
	}
	
	if(groupinfo_entity) {
		groupinfo_entity->v.groupinfo = groupinfo_entity_old;
		groupinfo_entity = 0;
	}
	
	// Set groupmask back if gamedll had it changed
	if(game_groupmask || game_groupop)
		ENGINE_SETGROUPMASK(game_groupmask, game_groupop);
}

//
// ...
//

static Vector check_CenterOrigin;
static float check_max_distance;

//
static int check_distance(edict_t *pEmiter, edict_t *pClient) {
	return((check_CenterOrigin - pClient->v.origin).Length() <= check_max_distance);
}

//
static void SetClientStatesByDistance(edict_t * entity, float max_distance, int invert) {
	check_max_distance = max_distance;
	check_CenterOrigin = GetEdictCenterOrigin(entity);
	SetClientStatesBy(entity, &check_distance, invert);
}

//
// tested this.. didn't make any sound because SetClientStatesByClient() didn't work
//
/*
//
// ...
//
static edict_t *check_pOne;

//
static int check_client(edict_t *pEmiter, edict_t *pClient) {
	return(pClient==check_pOne);
}

//
static void SetClientStatesByClient(edict_t * entity, edict_t * pClient, int invert=0) {
	check_pOne = entity;
	SetClientStatesBy(entity, &check_client, invert);
}

//
// Hack block .. move sound emiting entity randomly up and down while playing sound (+distance fix)
//
//      X
//     /|
//    / |
//   /  |
//  C---Y----A
//
// A is original place of sound emiting entity.
// C is client.
// X is new place of sound emiting entity.
// Distance between C and X is same as distance between C and A.
// Distance between Y and X is less than distance between C and A. 
//    Random value from 64 to min(C->A / sqrt(2), 256) or max(-(C->A / sqrt(2)), -256) to -64.
//
//   pow(C->X, 2) = pow(C->Y, 2) + pow(Y->X, 2)
//    ->
//   C->Y = sqrt(pow(C->A, 2) - pow(Y->X, 2))
//
int EmitSound_HackBlock(edict_t *entity, int channel, const char *sample, float volume, float attenuation, int fFlags, int pitch) {
	//zero means play everywhere
	if(attenuation <= 0.0f)
		return(0);
	
	float max_distance = get_maxdistance(attenuation, volume);
	
	const float inv_sqrt2 = 1/sqrt(2);
	float C_A, C_Y, Y_X;
	Vector SoundDirection;
	
	//
	Vector CenterOrigin = GetEdictCenterOrigin(entity);
		
	for(int i = 1; i <= gpGlobals->maxClients; i++) {
		if(!player_is_connected[i-1])
			continue;
		
		edict_t * pClient = INDEXENT(i);
		bool moved = false;
		
		//get distance
		Vector OldOrigin = entity->v.origin;
		
		//get direction where sound it emited
		SoundDirection = CenterOrigin - pClient->v.origin;
		C_A = SoundDirection.Length();
		SoundDirection = Vector(SoundDirection.x, SoundDirection.y, 0).Normalize() * C_A;
		
		//need some distance to work
		if(C_A > 64 && (CenterOrigin.Make2D() - pClient->v.origin.Make2D()).Length() >= 64*inv_sqrt2) {
			//distance fix
			if(C_A > max_distance)
				//too far
				continue;
			
			// calculate new position
			Y_X = RANDOM_FLOAT(64, min(inv_sqrt2 * C_A, 256)) * (RANDOM_LONG(0,1)?-1:1);
			C_Y = sqrt(C_A*C_A + Y_X*Y_X);
			
			entity->v.origin = pClient->v.origin + Vector(SoundDirection.x, SoundDirection.y, Y_X).Normalize() * C_A;
			moved = true;
			
			//for debuging
			Debug_Sparks(CenterOrigin, );
		}
		
		//play
		SetClientStatesByClient(entity, pClient, 0);
		
		//Now call original function
		(*g_engfuncs.pfnEmitSound)(entity, channel, sample, volume, attenuation, fFlags, pitch);
		
		//Reset client states to normal
		ResetClientStates();
		
		if(moved) {
			entity->v.origin = OldOrigin;
		}
	}
	
	return(1);
}
*/

//
// g_engfuncs.pfnEmitSound replacement
//
int EmitSound_DistanceFix(edict_t *entity, int channel, const char *sample, float volume, float attenuation, int fFlags, int pitch) {
	//return(EmitSound_HackBlock(entity, channel, sample, volume, attenuation, fFlags, pitch));
	
	//zero means play everywhere
	if(attenuation <= 0.0f || (int)CVAR_GET_FLOAT("dsb_on")<=0)
		return(0);
	
	//Set ClientStates By Distance
	SetClientStatesByDistance(entity, get_maxdistance(attenuation, volume), 0);
	
	//Now call original function
	(*g_engfuncs.pfnEmitSound)(entity, channel, sample, volume, attenuation, fFlags, pitch);
	
	//Reset client states to normal
	ResetClientStates();
	
	return(1);
}

//
// pmove->PM_PlaySound replacement
//
void PM_PlaySound_DistanceFix(int channel, const char *sample, float volume, float attenuation, int fFlags, int pitch) {
	//zero means play everywhere
	if(attenuation <= 0.0f || (int)CVAR_GET_FLOAT("dsb_on")<=0) {
		(*OLD_PM_PlaySound)(channel, sample, volume, attenuation, fFlags, pitch);
		
		return;
	}
	
	//EmitSound_HackBlock(INDEXENT(g_pmove->player_index+1), channel, sample, volume, attenuation, fFlags, pitch);return;
	
	//no entity as parameter, take player entity
	edict_t *entity = INDEXENT(g_pmove->player_index+1);
	
	//Set ClientStates By Distance
	SetClientStatesByDistance(entity, get_maxdistance(attenuation, volume), 0);
	
	//Now call original function
	(*OLD_PM_PlaySound)(channel, sample, volume, attenuation, fFlags, pitch);
	
	//Reset client states to normal
	ResetClientStates();
}

//
// g_engfuncs.pfnPlaybackEvent post fix - Send "null" sound to players that are too far away
//
/*
void PlaybackEvent_DistanceFix(edict_t *entity, unsigned short eventindex) {
	//Check if entity is client
	int index = ENTINDEX(entity);
	if(index <= 0 || index > gpGlobals->maxClients)
		return;
	
	//Set ClientStates By Distance
	SetClientStatesByDistance(entity, MAX_DISTANCE / ATTN_NORM, 1);
	
	(*g_engfuncs.pfnEmitSound)(entity, CHAN_WEAPON, "common/null.wav", 1.0f, ATTN_NONE, 0, PITCH_NORM);
	(*g_engfuncs.pfnEmitSound)(entity, CHAN_ITEM, "common/null.wav", 1.0f, ATTN_NONE, 0, PITCH_NORM);
	
	//Reset client states to normal
	ResetClientStates();
}
*/
