#include <extdll.h>
#include <sdk_util.h>
#include <meta_api.h>
#include "distantsoundblock.h"

static void ServerDeactivate(void) {
	memset(&player_is_connected, 0, sizeof(player_is_connected));
	
	RETURN_META(MRES_HANDLED);
}

static void ClientPutInServer(edict_t *pThis) {
	int id = ENTINDEX(pThis);
	
	if(id < 1 || id > 32)
		RETURN_META(MRES_IGNORED);
	
	player_is_connected[id-1] = 1;
	
	RETURN_META(MRES_HANDLED);
}

static void PM_Move(struct playermove_s *ppmove, int) {
	//Fix bots
	if(ppmove->player_index >= 0 && ppmove->player_index < 32) {
		if(!player_is_connected[ppmove->player_index]) {
			ClientPutInServer(INDEXENT(ppmove->player_index+1));
		}
	}
	
	if(ppmove->PM_PlaySound != PM_PlaySound_DistanceFix) {
		g_pmove = ppmove;
		OLD_PM_PlaySound = g_pmove->PM_PlaySound;
		g_pmove->PM_PlaySound = PM_PlaySound_DistanceFix;
	}
	
	RETURN_META(MRES_HANDLED);
}

static void ClientDisconnect(edict_t *pThis) {
	int id = ENTINDEX(pThis);
	
	if(id < 1 || id > 32)
		RETURN_META(MRES_IGNORED);
	
	player_is_connected[id-1] = 0;
	
	RETURN_META(MRES_HANDLED);
}

int plugin_GetEntityAPI2(DLL_FUNCTIONS *pFunctionTable, int *interfaceVersion) {
	memset(pFunctionTable, 0, sizeof(DLL_FUNCTIONS));
	
	pFunctionTable->pfnPM_Move = PM_Move;
	pFunctionTable->pfnClientPutInServer = ClientPutInServer;
	pFunctionTable->pfnClientDisconnect = ClientDisconnect;
	pFunctionTable->pfnServerDeactivate = ServerDeactivate;
	
	return(TRUE);
}
